aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorPetr Štetiar <ynezz@true.cz>2020-11-01 14:40:02 +0100
committerJo-Philipp Wich <jo@mein.io>2021-03-20 13:44:44 +0100
commitdce6b118eb9f9c43f93de3a4570d5b36f731e62e (patch)
treeef76df87a0d1ca38ea43b1fa4594a40611ffc1ed
parentafdd5dcd0dcad635be8d3bddb860844e2f937409 (diff)
downloadupstream-dce6b118eb9f9c43f93de3a4570d5b36f731e62e.tar.gz
upstream-dce6b118eb9f9c43f93de3a4570d5b36f731e62e.tar.bz2
upstream-dce6b118eb9f9c43f93de3a4570d5b36f731e62e.zip
scripts: bundle-libraries.sh: fix broken SDK compiler
Recent versions (> 5.33) of `file` report liblto_plugin.so as executable: $ file liblto_plugin.so liblto_plugin.so.0.0.0: ELF 64-bit LSB pie executable ... Which then leads to improper packaging of the plugin, resulting in the broken compiler: configure: checking whether the C compiler works mips-openwrt-linux-musl/bin/ld: liblto_plugin.so: error loading plugin: liblto_plugin.so: invalid ELF header As the LTO compiler plugin library is incorrectly packaged as SDK executable: $ head -1 ~/staging_dir/toolchain...libexec/gcc/.../liblto_plugin.so #!/usr/bin/env bash Fix this by filtering out shared libraries from the patching. Ref: https://bugzilla.redhat.com/show_bug.cgi?id=1296868 Acked-by: Jo-Philipp Wich <jo@mein.io> Signed-off-by: Petr Štetiar <ynezz@true.cz> (cherry picked from commit 4b7165722cb0e2ba62ab68e8b90d4d4b0909744c)
-rwxr-xr-xscripts/bundle-libraries.sh19
1 files changed, 18 insertions, 1 deletions
diff --git a/scripts/bundle-libraries.sh b/scripts/bundle-libraries.sh
index d3c7206a4d..90002453ec 100755
--- a/scripts/bundle-libraries.sh
+++ b/scripts/bundle-libraries.sh
@@ -125,6 +125,23 @@ _patch_glibc() {
fi
}
+should_be_patched() {
+ local bin="$1"
+
+ [ -x "$bin" ] || return 1
+
+ case "$bin" in
+ *.so|*.so.[0-9]*)
+ return 1
+ ;;
+ *)
+ file "$bin" | grep -sqE "ELF.*(executable|interpreter)" && return 0
+ ;;
+ esac
+
+ return 1
+}
+
for LDD in ${PATH//://ldd }/ldd; do
"$LDD" --version >/dev/null 2>/dev/null && break
LDD=""
@@ -150,7 +167,7 @@ for BIN in "$@"; do
LDSO=""
- [ -n "$LDD" ] && [ -x "$BIN" ] && file "$BIN" | grep -sqE "ELF.*(executable|interpreter)" && {
+ [ -n "$LDD" ] && should_be_patched "$BIN" && {
for token in $("$LDD" "$BIN" 2>/dev/null); do
case "$token" in */*.so*)
dest="$DIR/lib/${token##*/}"